package gomoku;

public class Model implements ModelIntf {
	
	final private int goal ;
	final private int rows;
	final private int cols;
	private int turn;
	final int[][] grid ;

	public Model(int rows, int cols, int goal) {
		this.rows = rows ;
		this.cols = cols ;
		this.goal = goal ;
		turn = BLACK ;
		grid = new int[rows][cols] ;
		for( int i = 0 ; i < rows ; ++i ) {
			for( int j = 0 ; j < cols ; ++j ) {
				grid[i][j] = EMPTY ; } }
	}

	@Override
	public int getRows() {
		return rows;
	}

	@Override
	public int getCols() {
		return rows;
	}
	
	private boolean look( int i, int j, int di, int dj ) {
		int colour = grid[i][j] ;
		int count = 1 ;
		while( count < goal ) {
			i += di ; j += dj ;
			if( 0 <= i && i < rows && 0 <= j && j < cols ) {
				if( grid[i][j] != colour ) return false ;
			} else {
				return false ; } 
			count ++ ;}
		return true ;
	}

	@Override
	public int winner() {
		for( int i = 0 ; i < rows ; ++i ) {
			for( int j = 0 ; j < cols ; ++j ) {
				if( grid[i][j] != EMPTY
					&& ( look( i, j, 0, 1) 
				       || look( i, j, 1, 0)
				       || look( i, j, 1, -1)
				       || look( i, j, 1, +1))) return grid[i][j] ;
			}
		}
		return EMPTY;
	}

	@Override
	public int turn() {
		return turn;
	}

	@Override
	public int getColor(int row, int col) {
		return grid[row][col];
	}

	@Override
	public void put(int row, int col) {
		grid[row][col] = turn ;
		turn = - turn ;
	}
}
