package gomoku;

public interface ModelIntf {
	
	/** How many rows are there */
	int getRows() ;
	
	/** How many columns are there */
	int getCols() ;
	
	static final int WHITE = -1 ;
	
	static final int BLACK = 1 ;
	
	static final int EMPTY = 0 ;
	
	/** Is there a winner and, if so, who?
	 * Returns EMPTY if there is no winner.
	 * Otherwise the colour of the winner: BLACK or WHITE. */
	int winner() ;
	
	/** Whose turn is it? */
	int turn() ;
	
	/** What colour is at position (row,col).
	 * Precondition: 0 <= row < getRows()
	 * Precondition: 0 <= col < getCols() 
	 * @param row
	 * @param col
	 * @return
	 */
	int getColor(int row, int col) ;
	/** Put a token at (row, col)
	 * Precondition: 0 <= row < getRows()
	 * Precondition: 0 <= col < getCols() 
	 * Precondition: getWinner() == EMPTY
	 * Precondition: getColor( row, col) == EMPTY
	 * 
	 * @param row
	 * @param col
	 */
	void put( int row, int col) ;
}
