package gomoku;

import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

public class View extends JFrame {
	class MyButton extends JButton {


		private void moveTo(int row, int col) {
			if( mod.winner() == mod.EMPTY
		     && mod.getColor(row, col)==mod.EMPTY ) {
				int turn = mod.turn() ;
				Color color = turn==mod.WHITE ? Color.WHITE : Color.BLACK ;
				mod.put(row, col) ;
				setBackground(color) ; 
				checkForWinner() ;
				turn = mod.turn() ;
				String name = (turn==mod.WHITE ? "White" : "Black") ;
				setTitle( name + " to move") ; }
		}
		
		MyButton( final int row, final int col ) {
			setBackground(Color.LIGHT_GRAY) ;

			addActionListener(new ActionListener() {
				@Override public void actionPerformed(ActionEvent ev) {
					moveTo(row, col) ; } } ) ;
		} }


	ModelIntf mod ;

	View() {
		restart() ;
	}

	private void restart() {
		int size = 0 ;
		String message = "Enter the board size" ;
		do {
			String response = JOptionPane.showInputDialog(message, "19" ) ;
			if( response == null ) System.exit(1) ;
			try {size = Integer.valueOf(response) ;
			if( size < 3 || size > 20) {
				size = 0 ;
				message = "The board size should be between 3 and 20.\n"+
						"Enter the board size." ; } }
			catch( Throwable ex) {}
		} while( size <= 0 ) ;
		
		int goal = 0 ;
		message = "Enter the goal" ;
		do {
			String response = JOptionPane.showInputDialog(message, "5" ) ;
			if( response == null ) System.exit(1) ;
			try {goal = Integer.valueOf(response) ;
			if( goal < 3 || goal > size) {
				goal = 0 ;
				message = "The goal should be between 3 and " +size+ ".\n"+
						"Enter the goal." ; } }
			catch( Throwable ex) {}
		} while( goal <= 0 ) ;

		getContentPane().removeAll() ;

		mod = new Model( size, size, goal ) ;

		setSize( 20*mod.getCols(), 20*mod.getRows() ) ;
		setLayout(new GridLayout(mod.getRows(), mod.getCols()) ) ;
		for( int r = 0 ; r < mod.getRows() ; ++r ) {
			for( int c = 0 ; c < mod.getCols() ; ++c ) {
				JButton jb = new MyButton(r, c) ;
				add(jb) ;
			}
		}
		setVisible(true) ;
	}

	private void checkForWinner() {
		int winner = mod.winner();
		if( winner != mod.EMPTY ) {
			String color = winner== mod.WHITE ? "White" : "Black" ;
			JOptionPane.showMessageDialog(this, color + " wins");
			int response = JOptionPane.showConfirmDialog(this, "Play again", "Play again", JOptionPane.YES_NO_OPTION) ;
			if( response == JOptionPane.YES_OPTION ) restart() ;
			else System.exit(1) ;
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			UIManager.setLookAndFeel(
					UIManager.getCrossPlatformLookAndFeelClassName());
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(1) ; }
		SwingUtilities.invokeLater(new Runnable() {

			@Override
			public void run() {
				View v = new View(  ) ;
			}
		}) ; 
	}


}
